/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.ruoyi.common.core.utils.ServletUtils
 *  com.ruoyi.common.core.utils.poi.ExcelUtil
 *  com.ruoyi.common.core.web.controller.BaseController
 *  com.ruoyi.common.core.web.domain.AjaxResult
 *  com.ruoyi.common.core.web.page.TableDataInfo
 *  com.ruoyi.common.log.annotation.Log
 *  com.ruoyi.common.log.enums.BusinessType
 *  com.ruoyi.common.security.annotation.RequiresPermissions
 *  com.ruoyi.common.security.service.TokenService
 *  com.ruoyi.system.api.model.LoginUser
 *  com.ruoyi.system.controller.SnTemplateController
 *  com.ruoyi.system.domain.SnTemplate
 *  com.ruoyi.system.service.ISnTemplateService
 *  javax.servlet.http.HttpServletResponse
 *  org.springframework.beans.factory.annotation.Autowired
 *  org.springframework.web.bind.annotation.DeleteMapping
 *  org.springframework.web.bind.annotation.GetMapping
 *  org.springframework.web.bind.annotation.PathVariable
 *  org.springframework.web.bind.annotation.PostMapping
 *  org.springframework.web.bind.annotation.PutMapping
 *  org.springframework.web.bind.annotation.RequestBody
 *  org.springframework.web.bind.annotation.RequestMapping
 *  org.springframework.web.bind.annotation.RestController
 */
package com.ruoyi.system.controller;

import com.ruoyi.common.core.utils.ServletUtils;
import com.ruoyi.common.core.utils.poi.ExcelUtil;
import com.ruoyi.common.core.web.controller.BaseController;
import com.ruoyi.common.core.web.domain.AjaxResult;
import com.ruoyi.common.core.web.page.TableDataInfo;
import com.ruoyi.common.log.annotation.Log;
import com.ruoyi.common.log.enums.BusinessType;
import com.ruoyi.common.security.annotation.RequiresPermissions;
import com.ruoyi.common.security.service.TokenService;
import com.ruoyi.system.api.model.LoginUser;
import com.ruoyi.system.domain.SnTemplate;
import com.ruoyi.system.service.ISnTemplateService;
import java.util.List;
import javax.servlet.http.HttpServletResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping(value={"/SnTemplate"})
public class SnTemplateController
extends BaseController {
    @Autowired
    private ISnTemplateService snTemplateService;
    @Autowired
    private TokenService tokenService;

    @GetMapping(value={"/selectList"})
    public AjaxResult selectList(SnTemplate snTemplate) {
        LoginUser loginUser = this.tokenService.getLoginUser(ServletUtils.getRequest());
        if (!loginUser.getRoles().contains("admin")) {
            snTemplate.setStatus(Integer.valueOf(1));
        }
        snTemplate.getParams().put("excludeBack", 1);
        List list = this.snTemplateService.selectSnTemplateList(snTemplate);
        return AjaxResult.success((Object)list);
    }

    @RequiresPermissions(value={"system:SnTemplate:list"})
    @GetMapping(value={"/list"})
    public TableDataInfo list(SnTemplate snTemplate) {
        this.startPage();
        LoginUser loginUser = this.tokenService.getLoginUser(ServletUtils.getRequest());
        if (!loginUser.getRoles().contains("admin")) {
            snTemplate.setStatus(Integer.valueOf(1));
        }
        Long userId = null;
        if (!loginUser.getRoles().contains("admin") && !loginUser.getRoles().contains("super")) {
            userId = loginUser.getUserid();
        }
        snTemplate.getParams().put("excludeBack", 1);
        if (userId != null) {
            snTemplate.getParams().put("userId", userId);
        }
        List list = this.snTemplateService.selectSnTemplateList(snTemplate);
        return this.getDataTable(list);
    }

    @RequiresPermissions(value={"system:SnTemplate:export"})
    @Log(title="生态模板", businessType=BusinessType.EXPORT)
    @PostMapping(value={"/export"})
    public void export(HttpServletResponse response, SnTemplate snTemplate) {
        List list = this.snTemplateService.selectSnTemplateList(snTemplate);
        ExcelUtil util = new ExcelUtil(SnTemplate.class);
        util.exportExcel(response, list, "生态模板数据");
    }

    @RequiresPermissions(value={"system:SnTemplate:query"})
    @GetMapping(value={"/{templateId}"})
    public AjaxResult getInfo(@PathVariable(value="templateId") Long templateId) {
        return this.success((Object)this.snTemplateService.selectSnTemplateByTemplateId(templateId));
    }

    @PostMapping(value={"/countryNum"})
    public AjaxResult countryNum() {
        return this.snTemplateService.countryNum();
    }

    @RequiresPermissions(value={"system:SnTemplate:add"})
    @Log(title="生态模板", businessType=BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody SnTemplate snTemplate) {
        return this.toAjax(this.snTemplateService.insertSnTemplate(snTemplate));
    }

    @RequiresPermissions(value={"system:SnTemplate:edit"})
    @Log(title="生态模板", businessType=BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody SnTemplate snTemplate) {
        return this.toAjax(this.snTemplateService.updateSnTemplate(snTemplate));
    }

    @RequiresPermissions(value={"system:SnTemplate:remove"})
    @Log(title="生态模板", businessType=BusinessType.DELETE)
    @DeleteMapping(value={"/{templateIds}"})
    public AjaxResult remove(@PathVariable Long[] templateIds) {
        return this.snTemplateService.deleteSnTemplateByTemplateIds(templateIds);
    }
}

